import * as React from "react";
import { ISelected, IDropObj, Idrop, filedObj, Inode } from "./combo";
import { IImmutalbeMap, IImmutalbeList } from "../util/immutableUtil";
declare type props<T> = {
    data: T[];
    idField?: string;
    textField?: string;
    noIcon?: boolean;
    noSearch?: boolean;
    disabled?: boolean;
    multiply?: boolean;
    tit?: string;
    field: string;
    itemIcon?: string;
    defaultVal?: string;
    width?: number;
    maxHeight?: number;
    dropWidth?: number;
    directionUp?: boolean;
    noRequire?: boolean;
    renderCallback?: boolean;
    ableClear?: boolean;
    initComboVal?: {
        id: string;
    };
    clickOrCheckForbid?: (node: IImmutalbeMap<Inode & T>, field: string, selectedArr: states['selected']) => boolean;
    formatterVal?: (selected: states["selected"]) => React.ReactChild;
    formatterDropItem?: (node: IImmutalbeMap<Inode & T>) => React.ReactChild;
    clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T>): void;
};
declare type states = {
    selected: IImmutalbeList<ISelected>;
    drop: boolean;
};
interface ICombo<T> {
    eventId: string;
    dropStyle: {
        maxHeight: number;
    };
    selectFn(path?: string): void;
    dropToggle(e: React.MouseEvent): void;
    changeSelect(selected: states["selected"], node?: IImmutalbeMap<Inode & T>): void;
}
declare type IcomboType = keyof IDropObj;
declare const wrapComboHC: <P extends keyof IDropObj>(Drop: React.ComponentType<Idrop<P, any>>, comboType: IcomboType) => {
    new <T>(prop: props<T> & IDropObj[P]): {
        eventId: string;
        filedObj: IImmutalbeMap<filedObj<P, T>, filedObj<P, T>>;
        dropStyle: {
            maxHeight: number;
        };
        selectFn: (path?: string | undefined) => void;
        bindSelectFn: (fn: (path?: string | undefined) => void) => void;
        initFieldObj(prop: props<T> & IDropObj[P]): void;
        dropToggle: (e: React.MouseEvent) => void;
        initState(): states;
        documentClickFn: () => void;
        componentDidMount(): void;
        componentWillUnmount(): void;
        initSelect: (selecteds: states["selected"]) => void;
        changeSelect: (selecteds: states["selected"], node?: IImmutalbeMap<Inode & T, Inode & T> | undefined) => void;
        renderCombox(): JSX.Element;
        render(): JSX.Element;
        context: any;
        setState<K extends keyof states>(state: states | ((prevState: Readonly<states>, props: Readonly<props<T> & IDropObj[P]>) => states | Pick<states, K> | null) | Pick<states, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<props<T> & IDropObj[P]> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<states>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<props<T> & IDropObj[P]>, nextState: Readonly<states>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<props<T> & IDropObj[P]>, prevState: Readonly<states>): any;
        componentDidUpdate?(prevProps: Readonly<props<T> & IDropObj[P]>, prevState: Readonly<states>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<props<T> & IDropObj[P]>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<props<T> & IDropObj[P]>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<props<T> & IDropObj[P]>, nextState: Readonly<states>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<props<T> & IDropObj[P]>, nextState: Readonly<states>, nextContext: any): void;
    };
    defaultProps: {
        idField: string;
        textField: string;
        childField: string;
        width: number;
        maxHeight: number;
        defaultVal: string;
        clickOrCheckForbid: () => boolean;
    };
    contextType?: React.Context<any> | undefined;
};
export default wrapComboHC;
