import * as React from "react";
import * as Immutable from "immutable";
import { activeStatus } from "./DropItem";
import { Idrop, ISelected, Inode } from "./combo";
import { IImmutalbeMap, IImmutalbeList } from "../util/immutableUtil";
declare type props<T> = Idrop<"tree", T>;
declare type states<T> = {
    immutableData: Immutable.List<IImmutalbeMap<Inode & T>>;
    preData: T[];
    preInitComboVal: props<T>['initComboVal'];
    oldSelectedIndex: string;
    asyncDefaultVal: boolean;
};
interface IDropTree<T> {
    initState(prop: props<T>): states<T>;
}
declare class DropTree<T extends AnyObj> extends React.PureComponent<props<T>, states<T>> implements IDropTree<T> {
    static getDerivedStateFromProps(nextProps: props<AnyObj>, preState: states<AnyObj>): Partial<states<AnyObj>> | null;
    constructor(prop: props<T>);
    initState(prop: props<T>): states<T>;
    clear(): void;
    clickItem: (id?: string | undefined) => void;
    searchMap(data: T[], childField: string, key: string, textField: string): T[];
    searchFn: (key: string) => void;
    clickFnForTreeMethod: (path: string) => void;
    clickFn(index: string): void;
    checkMethod: (path: string) => void;
    checkFn(value: string): void;
    mapFn(list: IImmutalbeList<IImmutalbeMap<Inode & T>>, active: activeStatus, select: IImmutalbeList<ISelected>, filedObj: {
        idField: string;
        textField: string;
        childField: string;
    }): {
        arr: Immutable.List<IImmutalbeMap<Inode & T, Inode & T>>;
        selecte: IImmutalbeList<ISelected>;
    };
    checkForPar: (value: string) => void;
    checkForParFn(value: string): void;
    closeFn: () => void;
    toggleExpand: (index: string) => void;
    main(): JSX.Element;
    render(): JSX.Element | null;
}
export { DropTree };
declare const _default: {
    new <T>(prop: {
        data: T[];
        idField?: string | undefined;
        textField?: string | undefined;
        noIcon?: boolean | undefined;
        noSearch?: boolean | undefined;
        disabled?: boolean | undefined;
        multiply?: boolean | undefined;
        tit?: string | undefined;
        field: string;
        itemIcon?: string | undefined;
        defaultVal?: string | undefined;
        width?: number | undefined;
        maxHeight?: number | undefined;
        dropWidth?: number | undefined;
        directionUp?: boolean | undefined;
        noRequire?: boolean | undefined;
        renderCallback?: boolean | undefined;
        ableClear?: boolean | undefined;
        initComboVal?: {
            id: string;
        } | undefined;
        clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
        formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
        formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
        clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
    } & {
        childField?: string | undefined;
        noSearch?: boolean | undefined;
        parAbleClick?: boolean | undefined;
    }): {
        eventId: string;
        filedObj: IImmutalbeMap<import("./combo").filedObj<"tree", T>, import("./combo").filedObj<"tree", T>>;
        dropStyle: {
            maxHeight: number;
        };
        selectFn: (path?: string | undefined) => void;
        bindSelectFn: (fn: (path?: string | undefined) => void) => void;
        initFieldObj(prop: {
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }): void;
        dropToggle: (e: React.MouseEvent<Element, MouseEvent>) => void;
        initState(): {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        };
        documentClickFn: () => void;
        componentDidMount(): void;
        componentWillUnmount(): void;
        initSelect: (selecteds: IImmutalbeList<ISelected>) => void;
        changeSelect: (selecteds: IImmutalbeList<ISelected>, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined) => void;
        renderCombox(): JSX.Element;
        render(): JSX.Element;
        context: any;
        setState<K extends keyof {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>(state: {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        } | ((prevState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, props: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>) => {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        } | Pick<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }, K> | null) | Pick<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, prevState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>): any;
        componentDidUpdate?(prevProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, prevState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: IImmutalbeMap<Inode & T, Inode & T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: IImmutalbeMap<Inode & T, Inode & T>) => React.ReactChild) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<Inode & T, Inode & T> | undefined): void;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, nextContext: any): void;
    };
    defaultProps: {
        idField: string;
        textField: string;
        childField: string;
        width: number;
        maxHeight: number;
        defaultVal: string;
        clickOrCheckForbid: () => boolean;
    };
    contextType?: React.Context<any> | undefined;
};
export default _default;
