import * as React from "react";
import * as Immutable from "immutable";
import { Idrop, Inode } from "./combo";
import { IImmutalbeMap } from "../util/immutableUtil";
declare type immutableData<T> = Immutable.List<IImmutalbeMap<Inode & T>>;
declare type props<T> = {
    node: IImmutalbeMap<Inode & T>;
    fieldObj: Idrop<"tree", T>["filedObj"];
    index: string;
    lev: number;
    formatterDropItem?: (node: IImmutalbeMap<Inode & T>) => React.ReactNode;
    checkMethod(value: string): void;
    checkForPar(value: string): void;
    clickFn(index: string): void;
    toggleExpand(index: string): void;
};
declare type states = {};
interface IParTreeItem {
    toggleExpandFn(e: React.MouseEvent<HTMLDivElement>): void;
}
declare class ParTreeItem<T extends AnyObj> extends React.PureComponent<props<T>, states> implements IParTreeItem {
    static defaultProps: {
        childField: string;
    };
    state: states;
    checkFn: (e: React.ChangeEvent<HTMLInputElement>) => void;
    getCheckbox(text: string, expand: boolean): JSX.Element;
    getSubCom(childArr: immutableData<T>, lev: number, oindex: string): Immutable.List<JSX.Element>;
    toggleExpandFn: (e: React.MouseEvent<HTMLDivElement>) => void;
    render(): JSX.Element;
}
export default ParTreeItem;
