import * as React from "react";
import { GroupCols } from "./GroupCols";
import { activeStatus } from "./formatterTreeData";
import { ICommon, Inode } from "./mytreeTable";
import { IImmutalbeMap, IImmutalbeList } from "../../util/immutableUtil";
import { IScrollMethods } from "../../scroll/scroll";
declare type childType<T> = React.ComponentElement<ICommon<T>["groupCol"], React.ComponentState>;
declare type Props<T> = {
    data: T[];
    children: childType<T>[] | childType<T>;
    noOrder?: boolean;
    height?: number;
    multiply?: boolean;
    itemIcon?: string;
    childField?: string;
    originScroll?: boolean;
    idField: string;
    defaultSel?: string;
    tabField?: string;
    emptyTxt?: string;
    initSelectVal?: {
        id: string;
    };
    clickOrCheckForbid?: (node: IImmutalbeMap<T & Inode>, field?: string) => boolean;
    bindGetSelectedFn?: (getSelected: () => IImmutalbeList<IImmutalbeMap<T & Inode>>) => void;
};
declare type States<T> = {
    immutabData: IImmutalbeList<IImmutalbeMap<ICommon<T>["node"]>>;
    selectArr: IImmutalbeList<string>;
    preData: T[];
    preInitSelect?: {
        id: string;
    };
    isreLoad: boolean;
};
declare type config<T> = ICommon<T>["config"];
interface ITreeTable<T> {
    fieldArr: config<T>[];
    fixObj: ICommon<T>["fixObj"];
}
declare class TreeTable<T extends AnyObj> extends React.PureComponent<Props<T>, States<T>> implements ITreeTable<T> {
    static defaultProps: {
        idField: string;
        childField: string;
        defaultSel: string;
    };
    static getDerivedStateFromProps(nextProps: Props<AnyObj>, preState: States<AnyObj>): Partial<States<AnyObj>> | null;
    fixObj: ITreeTable<T>["fixObj"];
    tabMainTabBodyDomArr: HTMLDivElement[];
    tabMainTabBodyScrollFnArr: (IScrollMethods | undefined)[];
    fieldArr: ITreeTable<T>["fieldArr"];
    constructor(props: Props<T>);
    getFieldArr(arr: Props<T>["children"]): {
        child: (Omit<import("./mytreeTable").IColumnItem<T>, "children"> & {
            text: string;
        })[];
        width: number;
        forzen: boolean | undefined;
    }[];
    expand(path: string): void;
    checkChild(path: string): void;
    mapFn(list: IImmutalbeList<IImmutalbeMap<Inode & T>>, active: activeStatus, select: IImmutalbeList<string>): {
        arr: import("immutable").List<IImmutalbeMap<Inode & T, Inode & T>>;
        selecte: IImmutalbeList<string>;
    };
    checkPar(path: string): void;
    changeState: ICommon<T>["changeState"];
    initFixObj(): {
        tabField: string | undefined;
        emptyTxt: string | undefined;
        itemIcon: string | undefined;
        noOrder: boolean | undefined;
        idField: string;
        multiply: boolean | undefined;
        defaultSel: string | undefined;
        childField: string;
    };
    changeScrollTop: (top: number, index: number) => void;
    viewMap(): JSX.Element[];
    setTabBodyDom: (dom: HTMLDivElement, index: number, scrollBoxFn?: IScrollMethods | undefined) => void;
    setTabViewBottomFixHeight(): void;
    componentDidMount(): void;
    setSameH(): void;
    setDom(): void;
    componentDidUpdate(preProps: Props<T>): void;
    mapDom(domArr: HTMLDivElement[]): void;
    whileDomH(): void;
    render(): JSX.Element;
}
export { TreeTable, GroupCols };
