import * as React from "react";
import { ICommon } from "./mytablist";
declare type Props<T> = {
    data: ICommon<T>["data"];
    config: ICommon<T>["config"];
    fixObj: ICommon<T>["fixObj"];
    viewIndex: number;
    startIndex: number;
    changeState: ICommon<T>["changeState"];
    changeScrollTop(top: number, viewIndex: number): void;
    setTabBodyDom(dom: HTMLElement, viewIndex: number): void;
};
declare type States = {};
interface ITabView {
    scrollFn(e: React.UIEvent<HTMLDivElement>): void;
    overBox(): void;
    wheelFn(e: WheelEvent): void;
    makeSign(e: React.MouseEvent<HTMLDivElement>): void;
}
declare class TabView<T extends AnyObj> extends React.PureComponent<Props<T>, States> implements ITabView {
    state: States;
    colHeadRef: React.RefObject<HTMLDivElement>;
    tabBodyRef: React.RefObject<HTMLDivElement>;
    scrollFn: (e: React.UIEvent<HTMLDivElement>) => void;
    overBox(): void;
    wheelFn: (e: WheelEvent) => void;
    makeSign: (e: React.MouseEvent<HTMLDivElement>) => void;
    checkAll: (e: React.MouseEvent<HTMLSpanElement>) => void;
    getCheckAll(): JSX.Element;
    gethead(): JSX.Element;
    createColgroup(): JSX.Element;
    componentDidMount(): void;
    componentWillUnmount(): void;
    getBody(): JSX.Element;
    getMainBody(): JSX.Element;
    render(): JSX.Element;
}
export default TabView;
