import * as React from "react";
import { ICommon } from "./mytreeTable";
import { IImmutalbeMap } from "../util/immutableUtil";
declare type Props<T> = {
    cols: ICommon<T>["col"][];
    node: IImmutalbeMap<ICommon<T>["node"]>;
    fixObj: ICommon<T>["fixObj"];
    lev: number;
    index: string;
    isPar?: boolean;
    order: {
        order: number;
    };
    isMainView?: boolean;
    changeState: ICommon<T>["changeState"];
};
declare type States = {};
interface IItem {
    getFirstText(text: string): JSX.Element;
}
declare class Item<T extends AnyObj> extends React.PureComponent<Props<T>, States> implements IItem {
    state: States;
    getCheck(): JSX.Element | undefined;
    slideIconEvent: (e: React.MouseEvent<HTMLDivElement>) => void;
    getIcon(): JSX.Element;
    clickFn: (e: React.MouseEvent<HTMLDivElement>) => void;
    checkFn: (e: React.MouseEvent<HTMLSpanElement>) => void;
    getFirstText(text: string): JSX.Element;
    getOrder(): number;
    render(): JSX.Element;
}
export default Item;
